/*-----------------------------------------------------------------------------

 2002, Jeff M Soft und Hardware GmbH, All Rights Reserved

-----------------------------------------------------------------------------*/

#include "Module.h"
#include "SEMod_struct.h"
#include <assert.h>

void Module::open()
{
	SET_PROCESS_FUNC(Module::sub_process_sleep);

	SEModule_base::open();	// always call the base class
}

Module::Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1) : SEModule_base(seaudioMaster, p_resvd1)
{
}

// describe the pins (plugs and parameters)
bool Module::getPinProperties (long index, SEPinProperties* properties)
{
	switch( index )								// !!TODO!! list your in / out plugs
	{
	case 0:
		properties->name				= "SEED";
		properties->direction			= DR_PARAMETER;
		properties->datatype			= DT_INT;
		properties->flags				= IO_UI_COMMUNICATION;
		break;
	case 1:
		properties->name				= "Fill RGB";
		properties->direction			= DR_IN;
		properties->datatype			= DT_INT;
		properties->flags				= IO_UI_COMMUNICATION;
		break;
	case 2:
		properties->name				= "Randomise";
		properties->direction			= DR_IN;
		properties->datatype			= DT_BOOL;
		properties->flags				= IO_UI_COMMUNICATION;
		break;
	case 3:
		properties->name				= "Array";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_TEXT;
		properties->flags				= IO_UI_COMMUNICATION;
		break;
	default:
		return false; // host will ask for plugs 0,1,2,3 etc. return false to signal when done
	};

	return true;
}

void Module::sub_process_sleep(long buffer_offset, long sampleFrames )
{
	// nothing to do on DSP side. put module to sleep to save CPU
	CallHost(seaudioMasterSleepMode);
}
