#include "guimodule.h"
#include "it_enum_list.h"

#define PN_PITCH 0
#define PN_OCT 1
#define PN_OUT 2
#define NUMSLIDERS 16

GuiModule::GuiModule(seGuiCallback seaudioMaster, void *p_resvd1) : SEGUI_base(seaudioMaster, p_resvd1)
{
}

void GuiModule::Initialise(bool loaded_from_file)
{
	SEGUI_base::Initialise(loaded_from_file);

	values_array = new float [ NUMSLIDERS * sizeof(float) ];
/*
	if(!loaded_from_file)
	{
	}
*/
}

GuiModule::~GuiModule()
{
	delete values_array;
}

void GuiModule::OnGuiPinValueChange(SeGuiPin *p_pin)
{
	switch( p_pin->getIndex() )
	{
		case PN_PITCH:
		{
			processArrays();
			break;
		}
		case PN_OCT:
		{
			processArrays();
			break;
		}
		
		case PN_OUT:
		{
			break;
		}
		
	}
}


void GuiModule::processArrays()
{
	SeSdkString p(getPin(PN_PITCH)->getValueText());
	SeSdkString o(getPin(PN_OCT)->getValueText());
	
	int i = 0;
	while( p.length() > 0 && i < NUMSLIDERS )
	{
		int comma = p.find(",");

		int pitch = (int) StringToFloat( p.substr(comma-1,1) );
		//int oct = (int) StringToFloat( o.substr(comma-1,1) );

		values_array[i] = (pitch * 0.083333f);// + oct;

		i++;
		comma++;
		p = p.substr(comma, p.length() - comma);
		//o = o.substr(comma, o.length() - comma);
	}

	char v[300] = "";

	for( int i = 0 ; i < NUMSLIDERS; i++ )
	{
		char cell[20] = "";

		sprintf(cell,"%f,", values_array[i]);
		strcat(v,cell);
		assert( strlen(v) < 280 );
	}
	
	getPin(PN_OUT)->setValueText( v );

}

float GuiModule::StringToFloat(const SeSdkString &p_string)
{
	char * temp;	// convert string to float
	return (float) strtod( p_string.data(), &temp );
}